// Code generated by ent, DO NOT EDIT.

package allowlist

import (
	"time"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"github.com/crowdsecurity/crowdsec/pkg/database/ent/predicate"
)

// ID filters vertices based on their ID field.
func ID(id int) predicate.AllowList {
	return predicate.AllowList(sql.FieldEQ(FieldID, id))
}

// IDEQ applies the EQ predicate on the ID field.
func IDEQ(id int) predicate.AllowList {
	return predicate.AllowList(sql.FieldEQ(FieldID, id))
}

// IDNEQ applies the NEQ predicate on the ID field.
func IDNEQ(id int) predicate.AllowList {
	return predicate.AllowList(sql.FieldNEQ(FieldID, id))
}

// IDIn applies the In predicate on the ID field.
func IDIn(ids ...int) predicate.AllowList {
	return predicate.AllowList(sql.FieldIn(FieldID, ids...))
}

// IDNotIn applies the NotIn predicate on the ID field.
func IDNotIn(ids ...int) predicate.AllowList {
	return predicate.AllowList(sql.FieldNotIn(FieldID, ids...))
}

// IDGT applies the GT predicate on the ID field.
func IDGT(id int) predicate.AllowList {
	return predicate.AllowList(sql.FieldGT(FieldID, id))
}

// IDGTE applies the GTE predicate on the ID field.
func IDGTE(id int) predicate.AllowList {
	return predicate.AllowList(sql.FieldGTE(FieldID, id))
}

// IDLT applies the LT predicate on the ID field.
func IDLT(id int) predicate.AllowList {
	return predicate.AllowList(sql.FieldLT(FieldID, id))
}

// IDLTE applies the LTE predicate on the ID field.
func IDLTE(id int) predicate.AllowList {
	return predicate.AllowList(sql.FieldLTE(FieldID, id))
}

// CreatedAt applies equality check predicate on the "created_at" field. It's identical to CreatedAtEQ.
func CreatedAt(v time.Time) predicate.AllowList {
	return predicate.AllowList(sql.FieldEQ(FieldCreatedAt, v))
}

// UpdatedAt applies equality check predicate on the "updated_at" field. It's identical to UpdatedAtEQ.
func UpdatedAt(v time.Time) predicate.AllowList {
	return predicate.AllowList(sql.FieldEQ(FieldUpdatedAt, v))
}

// Name applies equality check predicate on the "name" field. It's identical to NameEQ.
func Name(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldEQ(FieldName, v))
}

// FromConsole applies equality check predicate on the "from_console" field. It's identical to FromConsoleEQ.
func FromConsole(v bool) predicate.AllowList {
	return predicate.AllowList(sql.FieldEQ(FieldFromConsole, v))
}

// Description applies equality check predicate on the "description" field. It's identical to DescriptionEQ.
func Description(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldEQ(FieldDescription, v))
}

// AllowlistID applies equality check predicate on the "allowlist_id" field. It's identical to AllowlistIDEQ.
func AllowlistID(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldEQ(FieldAllowlistID, v))
}

// CreatedAtEQ applies the EQ predicate on the "created_at" field.
func CreatedAtEQ(v time.Time) predicate.AllowList {
	return predicate.AllowList(sql.FieldEQ(FieldCreatedAt, v))
}

// CreatedAtNEQ applies the NEQ predicate on the "created_at" field.
func CreatedAtNEQ(v time.Time) predicate.AllowList {
	return predicate.AllowList(sql.FieldNEQ(FieldCreatedAt, v))
}

// CreatedAtIn applies the In predicate on the "created_at" field.
func CreatedAtIn(vs ...time.Time) predicate.AllowList {
	return predicate.AllowList(sql.FieldIn(FieldCreatedAt, vs...))
}

// CreatedAtNotIn applies the NotIn predicate on the "created_at" field.
func CreatedAtNotIn(vs ...time.Time) predicate.AllowList {
	return predicate.AllowList(sql.FieldNotIn(FieldCreatedAt, vs...))
}

// CreatedAtGT applies the GT predicate on the "created_at" field.
func CreatedAtGT(v time.Time) predicate.AllowList {
	return predicate.AllowList(sql.FieldGT(FieldCreatedAt, v))
}

// CreatedAtGTE applies the GTE predicate on the "created_at" field.
func CreatedAtGTE(v time.Time) predicate.AllowList {
	return predicate.AllowList(sql.FieldGTE(FieldCreatedAt, v))
}

// CreatedAtLT applies the LT predicate on the "created_at" field.
func CreatedAtLT(v time.Time) predicate.AllowList {
	return predicate.AllowList(sql.FieldLT(FieldCreatedAt, v))
}

// CreatedAtLTE applies the LTE predicate on the "created_at" field.
func CreatedAtLTE(v time.Time) predicate.AllowList {
	return predicate.AllowList(sql.FieldLTE(FieldCreatedAt, v))
}

// UpdatedAtEQ applies the EQ predicate on the "updated_at" field.
func UpdatedAtEQ(v time.Time) predicate.AllowList {
	return predicate.AllowList(sql.FieldEQ(FieldUpdatedAt, v))
}

// UpdatedAtNEQ applies the NEQ predicate on the "updated_at" field.
func UpdatedAtNEQ(v time.Time) predicate.AllowList {
	return predicate.AllowList(sql.FieldNEQ(FieldUpdatedAt, v))
}

// UpdatedAtIn applies the In predicate on the "updated_at" field.
func UpdatedAtIn(vs ...time.Time) predicate.AllowList {
	return predicate.AllowList(sql.FieldIn(FieldUpdatedAt, vs...))
}

// UpdatedAtNotIn applies the NotIn predicate on the "updated_at" field.
func UpdatedAtNotIn(vs ...time.Time) predicate.AllowList {
	return predicate.AllowList(sql.FieldNotIn(FieldUpdatedAt, vs...))
}

// UpdatedAtGT applies the GT predicate on the "updated_at" field.
func UpdatedAtGT(v time.Time) predicate.AllowList {
	return predicate.AllowList(sql.FieldGT(FieldUpdatedAt, v))
}

// UpdatedAtGTE applies the GTE predicate on the "updated_at" field.
func UpdatedAtGTE(v time.Time) predicate.AllowList {
	return predicate.AllowList(sql.FieldGTE(FieldUpdatedAt, v))
}

// UpdatedAtLT applies the LT predicate on the "updated_at" field.
func UpdatedAtLT(v time.Time) predicate.AllowList {
	return predicate.AllowList(sql.FieldLT(FieldUpdatedAt, v))
}

// UpdatedAtLTE applies the LTE predicate on the "updated_at" field.
func UpdatedAtLTE(v time.Time) predicate.AllowList {
	return predicate.AllowList(sql.FieldLTE(FieldUpdatedAt, v))
}

// NameEQ applies the EQ predicate on the "name" field.
func NameEQ(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldEQ(FieldName, v))
}

// NameNEQ applies the NEQ predicate on the "name" field.
func NameNEQ(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldNEQ(FieldName, v))
}

// NameIn applies the In predicate on the "name" field.
func NameIn(vs ...string) predicate.AllowList {
	return predicate.AllowList(sql.FieldIn(FieldName, vs...))
}

// NameNotIn applies the NotIn predicate on the "name" field.
func NameNotIn(vs ...string) predicate.AllowList {
	return predicate.AllowList(sql.FieldNotIn(FieldName, vs...))
}

// NameGT applies the GT predicate on the "name" field.
func NameGT(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldGT(FieldName, v))
}

// NameGTE applies the GTE predicate on the "name" field.
func NameGTE(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldGTE(FieldName, v))
}

// NameLT applies the LT predicate on the "name" field.
func NameLT(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldLT(FieldName, v))
}

// NameLTE applies the LTE predicate on the "name" field.
func NameLTE(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldLTE(FieldName, v))
}

// NameContains applies the Contains predicate on the "name" field.
func NameContains(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldContains(FieldName, v))
}

// NameHasPrefix applies the HasPrefix predicate on the "name" field.
func NameHasPrefix(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldHasPrefix(FieldName, v))
}

// NameHasSuffix applies the HasSuffix predicate on the "name" field.
func NameHasSuffix(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldHasSuffix(FieldName, v))
}

// NameEqualFold applies the EqualFold predicate on the "name" field.
func NameEqualFold(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldEqualFold(FieldName, v))
}

// NameContainsFold applies the ContainsFold predicate on the "name" field.
func NameContainsFold(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldContainsFold(FieldName, v))
}

// FromConsoleEQ applies the EQ predicate on the "from_console" field.
func FromConsoleEQ(v bool) predicate.AllowList {
	return predicate.AllowList(sql.FieldEQ(FieldFromConsole, v))
}

// FromConsoleNEQ applies the NEQ predicate on the "from_console" field.
func FromConsoleNEQ(v bool) predicate.AllowList {
	return predicate.AllowList(sql.FieldNEQ(FieldFromConsole, v))
}

// DescriptionEQ applies the EQ predicate on the "description" field.
func DescriptionEQ(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldEQ(FieldDescription, v))
}

// DescriptionNEQ applies the NEQ predicate on the "description" field.
func DescriptionNEQ(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldNEQ(FieldDescription, v))
}

// DescriptionIn applies the In predicate on the "description" field.
func DescriptionIn(vs ...string) predicate.AllowList {
	return predicate.AllowList(sql.FieldIn(FieldDescription, vs...))
}

// DescriptionNotIn applies the NotIn predicate on the "description" field.
func DescriptionNotIn(vs ...string) predicate.AllowList {
	return predicate.AllowList(sql.FieldNotIn(FieldDescription, vs...))
}

// DescriptionGT applies the GT predicate on the "description" field.
func DescriptionGT(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldGT(FieldDescription, v))
}

// DescriptionGTE applies the GTE predicate on the "description" field.
func DescriptionGTE(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldGTE(FieldDescription, v))
}

// DescriptionLT applies the LT predicate on the "description" field.
func DescriptionLT(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldLT(FieldDescription, v))
}

// DescriptionLTE applies the LTE predicate on the "description" field.
func DescriptionLTE(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldLTE(FieldDescription, v))
}

// DescriptionContains applies the Contains predicate on the "description" field.
func DescriptionContains(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldContains(FieldDescription, v))
}

// DescriptionHasPrefix applies the HasPrefix predicate on the "description" field.
func DescriptionHasPrefix(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldHasPrefix(FieldDescription, v))
}

// DescriptionHasSuffix applies the HasSuffix predicate on the "description" field.
func DescriptionHasSuffix(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldHasSuffix(FieldDescription, v))
}

// DescriptionIsNil applies the IsNil predicate on the "description" field.
func DescriptionIsNil() predicate.AllowList {
	return predicate.AllowList(sql.FieldIsNull(FieldDescription))
}

// DescriptionNotNil applies the NotNil predicate on the "description" field.
func DescriptionNotNil() predicate.AllowList {
	return predicate.AllowList(sql.FieldNotNull(FieldDescription))
}

// DescriptionEqualFold applies the EqualFold predicate on the "description" field.
func DescriptionEqualFold(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldEqualFold(FieldDescription, v))
}

// DescriptionContainsFold applies the ContainsFold predicate on the "description" field.
func DescriptionContainsFold(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldContainsFold(FieldDescription, v))
}

// AllowlistIDEQ applies the EQ predicate on the "allowlist_id" field.
func AllowlistIDEQ(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldEQ(FieldAllowlistID, v))
}

// AllowlistIDNEQ applies the NEQ predicate on the "allowlist_id" field.
func AllowlistIDNEQ(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldNEQ(FieldAllowlistID, v))
}

// AllowlistIDIn applies the In predicate on the "allowlist_id" field.
func AllowlistIDIn(vs ...string) predicate.AllowList {
	return predicate.AllowList(sql.FieldIn(FieldAllowlistID, vs...))
}

// AllowlistIDNotIn applies the NotIn predicate on the "allowlist_id" field.
func AllowlistIDNotIn(vs ...string) predicate.AllowList {
	return predicate.AllowList(sql.FieldNotIn(FieldAllowlistID, vs...))
}

// AllowlistIDGT applies the GT predicate on the "allowlist_id" field.
func AllowlistIDGT(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldGT(FieldAllowlistID, v))
}

// AllowlistIDGTE applies the GTE predicate on the "allowlist_id" field.
func AllowlistIDGTE(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldGTE(FieldAllowlistID, v))
}

// AllowlistIDLT applies the LT predicate on the "allowlist_id" field.
func AllowlistIDLT(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldLT(FieldAllowlistID, v))
}

// AllowlistIDLTE applies the LTE predicate on the "allowlist_id" field.
func AllowlistIDLTE(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldLTE(FieldAllowlistID, v))
}

// AllowlistIDContains applies the Contains predicate on the "allowlist_id" field.
func AllowlistIDContains(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldContains(FieldAllowlistID, v))
}

// AllowlistIDHasPrefix applies the HasPrefix predicate on the "allowlist_id" field.
func AllowlistIDHasPrefix(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldHasPrefix(FieldAllowlistID, v))
}

// AllowlistIDHasSuffix applies the HasSuffix predicate on the "allowlist_id" field.
func AllowlistIDHasSuffix(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldHasSuffix(FieldAllowlistID, v))
}

// AllowlistIDIsNil applies the IsNil predicate on the "allowlist_id" field.
func AllowlistIDIsNil() predicate.AllowList {
	return predicate.AllowList(sql.FieldIsNull(FieldAllowlistID))
}

// AllowlistIDNotNil applies the NotNil predicate on the "allowlist_id" field.
func AllowlistIDNotNil() predicate.AllowList {
	return predicate.AllowList(sql.FieldNotNull(FieldAllowlistID))
}

// AllowlistIDEqualFold applies the EqualFold predicate on the "allowlist_id" field.
func AllowlistIDEqualFold(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldEqualFold(FieldAllowlistID, v))
}

// AllowlistIDContainsFold applies the ContainsFold predicate on the "allowlist_id" field.
func AllowlistIDContainsFold(v string) predicate.AllowList {
	return predicate.AllowList(sql.FieldContainsFold(FieldAllowlistID, v))
}

// HasAllowlistItems applies the HasEdge predicate on the "allowlist_items" edge.
func HasAllowlistItems() predicate.AllowList {
	return predicate.AllowList(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.M2M, false, AllowlistItemsTable, AllowlistItemsPrimaryKey...),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasAllowlistItemsWith applies the HasEdge predicate on the "allowlist_items" edge with a given conditions (other predicates).
func HasAllowlistItemsWith(preds ...predicate.AllowListItem) predicate.AllowList {
	return predicate.AllowList(func(s *sql.Selector) {
		step := newAllowlistItemsStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// And groups predicates with the AND operator between them.
func And(predicates ...predicate.AllowList) predicate.AllowList {
	return predicate.AllowList(sql.AndPredicates(predicates...))
}

// Or groups predicates with the OR operator between them.
func Or(predicates ...predicate.AllowList) predicate.AllowList {
	return predicate.AllowList(sql.OrPredicates(predicates...))
}

// Not applies the not operator on the given predicate.
func Not(p predicate.AllowList) predicate.AllowList {
	return predicate.AllowList(sql.NotPredicates(p))
}
